hdu 2242

news/2024/11/30 10:35:32/

这题是双连通缩点,缩完点后原图会变成一棵树,这棵树的边就是割边,之后只要dfs一遍这颗树,取最小值即可,这题有个陷阱,就是有重边,显然如果有重边的话,这两个点可以构成双连通,我们只需标记一下是第几次走这条边即可,超过一次的话就是重边,要计算这条重边。

Run IDSubmit TimeJudge StatusPro.IDExe.TimeExe.MemoryCode Len.LanguageAuthor
54797342012-03-06 14:30:10Accepted2242218MS1716K2450 BG++xym2010

#include<cstdio>
#include<string>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<cmath>
#include<vector>
using namespace std;
int n,m,pos,ans,cnt,res[10005],head[10005],col[10005],dfn[10005],low[10005],bch,ord,stack[10005],top,tr[10005],sum[10005];
vector< pair<int,int> >brige;
bool vd[10005];
struct edge
{int v,next;
}eg[40005];
void insert(int x,int y)
{eg[pos].v=y,eg[pos].next=head[x],head[x]=pos++;
}
void tarjan(int u,int f)
{dfn[u]=low[u]=ord++;vd[u]=true;stack[top++]=u;int flag=0;//标记重边for(int i=head[u];i>=0;i=eg[i].next){int v=eg[i].v;if(v==f&&!flag&&(flag=1,1))continue;if(!vd[v])tarjan(v,u),low[u]=min(low[u],low[v]);else if(col[v]==-1)low[u]=min(low[u],dfn[v]);if(dfn[u]<low[v])brige.push_back(make_pair(u,v));}if(low[u]==dfn[u]){while(stack[top-1]!=u)col[stack[--top]]=bch,sum[bch]+=res[stack[top]];top--,sum[bch]+=res[stack[top]],col[u]=bch++;}
}
void buildT()
{memset(tr,-1,sizeof(tr));for(int i=0;i<brige.size();i++){int u=brige[i].first,v=brige[i].second;eg[pos].v=col[v],eg[pos].next=tr[col[u]];tr[col[u]]=pos++;eg[pos].v=col[u],eg[pos].next=tr[col[v]];tr[col[v]]=pos++;}
}
int dfs(int u)
{int tem=sum[u];vd[u]=1;for(int i=tr[u];i>=0;i=eg[i].next)if(!vd[eg[i].v])tem+=dfs(eg[i].v);ans=min(ans,abs(cnt-2*tem));return tem;
}
int main()
{int x,y;while(~scanf("%d%d",&n,&m)){cnt=0;for(int i=0;i<n;i++)scanf("%d",&res[i]),cnt+=res[i];memset(head,-1,sizeof(head));pos=0;for(int i=0;i<m;i++){scanf("%d%d",&x,&y);insert(x,y),insert(y,x);}bch=ord=top=0;memset(col,-1,sizeof(col));memset(vd,0,sizeof(vd));memset(sum,0,sizeof(sum));brige.clear();tarjan(0,0);if(bch==1)puts("impossible");else{buildT();ans=1<<29;memset(vd,0,sizeof(vd));dfs(0);printf("%d\n",ans);}}return 0;
}



http://www.ppmy.cn/news/500536.html

相关文章

hdu4217

/* 分析&#xff1a; 线段树。 代码不长&#xff0c;思路都在那个find子函数里面&#xff0c;注意要用64位 整数&#xff0c;至于32位的会不会WA&#xff0c;我没试&#xff0c;也不准备试-、-I&#xff0c;其它 的就没啥用解释的了&#xff0c;看不明白了再留言吧。 2012-10-2…

HDU 2474

这题关键是数据量太大&#xff0c;如果用普通的银行家算法&#xff0c;最坏情况下时间复杂度为O(N*N*M)&#xff0c;显然会超时。正确的解法是对每种资源分别考虑&#xff0c;建立M个队列。进程对每种资源的需求数量从小到大存入队列&#xff0c;这样每次只需检查队列头部的进程…

HDU 2147 PN 图

原文链接: HDU 2147 PN 图 上一篇: HDU 2897 邂逅明下&#xff08;巴什博弈&#xff09; 下一篇: HDU 3863 博弈 http://www.tuicool.com/articles/JFJZ3i 题意&#xff1a;给你n*m表格&#xff0c;初始在右上角&#xff0c;每次在上个人移动后的基础上移动一步&…

hdu 4681

题目 枚举&#xff21;&#xff0c;&#xff22;中的每一个子序列含&#xff23;的子串&#xff0c;长度尽量小&#xff0c;前后分别&#xff2c;&#xff23;&#xff33;。 #include<stdio.h> #include<string.h> #include<vector> #include<algorithm…

FZU1492

本题基于插入排序,不过用了STL容器set来做存储,因此插入结点成了O(logn)时间,总的时间复杂度大概到O(nlogn),利用了set的排序性质,省去了写二叉树的麻烦,起初用的n^2的扫描和快排后左右扫描的算法都不见理想. #include < stdio.h > #include < limits.h > #include…

hdu2412

/* 分析: 树形DP。 第一次写树形DP&#xff0c;敲了俩代码&#xff0c;一个是对于n大&#xff0c;要用 字典树辅助储存name的&#xff0c;不过写的太长&#xff0c;就不biada出来了&#xff0c; 另一个就是下面的了&#xff0c;参考了大牛的代码。 2012-09-05 */ #include"…

Aizu 2249

以dis为权值&#xff0c;求最短路&#xff0c;再开一个pre数组&#xff0c;pre[i]表示从首都到i城的最短路中&#xff0c;i城的上一座城市到i城的cost。最后将求出的最短路所有pre加起来就好了&#xff08;为什么这样&#xff0c;画图可以考虑考虑&#xff0c;大概还是有道理的…

sdut2404 Super Prime

输出有时候是YES NO&#xff0c;有时候是Yes No&#xff0c;有时候是yes no。 因为这个WA实在可惜&#xff0c;Be careful ! #include<iostream> #include<cstring> #include<cstdio> #include<cmath> using namespace std; #define M 100000 bool ma…